1.32.0 (stable):

* Require libgda 5.2.9, to support newer postgresql versions.
* Require Python 3.
* Require at least gtkmm 3.22
* Use some more modern C++ code.
* Avoid some compiler warnings.
* Correct build errors when srcdir != builddir
(Murray Cumming)

1.31.6 (unstable):

* Layout: Custom fonts: Fix regressoin in 1.31.5.
  (Murray Cumming)

1.31.5 (unstable):

* Avoid crash when trying to show GtkCssProvider errors.
* Don't use deprecated font: syntax with GtkCssProvider.
* Remove some unused code.
* Require libsigc++ 2.9.2, for the newer R(Args...) syntax.

1.31.4 (unstable):

* Prevent a crash (in the menu code) when using a table name containing a space,
  though there are still problems with that.
  (Murray Cumming) Bug #763534 (m.rick.mac)
* Lots of code refactoring and correcting.
  (Murray Cumming)

1.31.3 (unstable):

* Show the translated UI in non-English locales,
  even on newer Linux distros.
  (Murray Cumming) Bug #761372 (m.rick.mac)
* Default Field Formatting: Let people actually change this again,
  fixing a regression in (approx) Glom 1.25.4.
  (Murray Cumming) Bug #763348 (m.rick.mac)
* Help menu item: Make this work again with recent GNOME systems.
  (Murray Cumming) Bug #763250 (m.rick.mac)
* Export: Don't lose precision when exporting large numeric values.
  (Murray Cumming) Bug #763229 (m.rick.mac)

1.31.2 (unstable):

* Fix crash when loading images into an image field.
  (Murray Cumming)
* Fix crash caused by assert in recent versions of libevince-view.
  (Murray Cumming) Bug #761396 (m.rick.mac))
* Really forget a table when removing it.
  (Murray Cumming) Bug #754645 (m.rick.mac)
* Table deletion: Actually let the user cancel the dialog.
  (Murray Cumming)
* Initialize PostgresSQL database with the C locale.
  Because using the current locale seems arbitrary and useless to other users.
  (Murray Cumming) Bug #761372 (m.rick.mac)
* Try to catch filesystem errors sooner.
  (Murray Cumming) Bug #761373 (m.rick.mac)
* Details layout: Allow notebooks at top-level.
  (Murray Cumming) Bug #759511 (m.rick.mac)
* Connection to central server:
  - Ask again if the connection fails.
  (Murray Cumming)
  - Specify a timeout.
  (Murray Cumming)

Build:
* Check for, and require, C++14.
* Lots of modernization of the C++ source code.

1.31.1 (unstable):

* Build: Convert the source code to C++11.
* Build: Remove unused source code.
* Build: Use libxml++-3.0 instead of libxml++-2.6.
* Build: Improvements to how we find and use boost libraries.
  (Murray Cumming)

1.30.0 (stable):

* Dialog_FieldDefinition: Show self-triggering lookups as grayed-out.
  (Murray Cumming) Bug #754641 (m.rick.mac)
* Lookups: Prevent endless self lookups.
  (Murray Cumming)
* Use std::endl instead of std::cerr where std::endl was meant.
  (David Evans) Bug #754294
* Build: Disable use of yelp if --disable-documentation was used.
  This should apparently be useful on MacOS:
  https://trac.macports.org/ticket/44616
  (Murray Cumming)
* More use of C++11
  (Murray Cumming)
* EggSpreadTableDnd: Replace use of deprecated gtk_style_context_set_background.
  (Murray Cumming)
* Use property_whatever() instead of set_property("whatever").
  (Murray Cumming)
* ComboBox_Relationship: Fix a typo in a null check.
  (Murray Cumming)

1.29.5 (unstable):

* Fix the build with python 3 and require python 3.
  (Murray Cumming)
* Build with (and require) C++11, using some simple C++11 features.
  (Murray Cumming)

1.29.4 (unstable):

* Use libgda-5 again instead of libgda-6.
  Because libgda-6 is not quite ready and not likely to be stable soon enough.
  (Murray Cumming)

1.29.3 (unstable):

* Details: Let entry widgets expand to fill space,
  fixing a regression from 1.27.2.
  (Murray Cumming)
* Details: Make text alignment work again,
  fixing a regression from 1.27.2
  (Murray Cumming)
* Use the LC_TIME to get translated date formats, even when LANGUAGE is set.
  (Murray Cumming) Bug #742968


1.29.2 (unstable):

* Use the LC_TIME environment variable to get translated date formats.
  (Murray Cumming) Bug #742968
* Avoid a crash during shutdown.
  (Murray Cumming) Bug #741851
* Fix remaining warnings from the Coverity scan.
  (Murray Cumming)


1.29.1 (unstable):

* Use libgda-6.0 instead of libgda-5.0, though image fields are currently not
  working.
  (Murray Cumming)
* Fix the build with the latest gtkmm.
  (Murray Cumming)
* Fix several warnings from the Coverity scan.
  (Murray Cumming)
* Use the new Gio::Resource API from glibmm instead of the C API.
  (Murray Cumming)


1.28.0 (stable):

* Glade UI files:
  - Remove deprecated GtkContainer:resize-mode property.
  - FlowTableWithFields: Replace use of deprecated xalign and valign.
  - Replace stock properties with icon-name properties.


1.27.1 (unstable):

* Avoid use of deprecated gtkmm/GTK+ API in Glade files.
  For instance, GtkAlignment, and stock items.
  (Murray Cumming, Piotr Drąg)
* Adapt to recent Gtk::Builder child-widget ref-counting fixes in gtkmm.
  (Murray Cumming)
* Avoid new GTK+ warnings about dialogs without transient parent windows.
  (Murray Cumming)
* Application: Use non-deprecated gtkmm/GTK+ accelerators API.
  (Murray Cumming)


1.26.0 (stable):

* Reports: Fix a crash introduced in 1.25.4.
  (Murray Cumming)

1.25.6 (unstable):

* Backup/Restore: Use libarchive instead of calling the tar shell command.
  This should be slightly more robust and safe, though we were already
  correctly escaping and quoting the shell commands.
  (Murray Cumming)
* Avoid an infinite loop when document loading fails.
  (Murray Cumming)

1.25.5 (unstable):

* Check that we have the pg_config utility.
  (Murray Cumming)
* Add some tests.
  (Murray Cumming)
* Slight improvements to the libglom API.
  (Murray Cumming)

1.25.4 (unstable):

* Fix a crash when switching between Data and Find mode.
  (Murray Cumming)
* Fix some widget expansion in the UI.
  (Murray Cumming)
* Formatting: Do not allow a 0 line-height for multiline text.
  (Murray Cumming)
* Added some more tests.
  (Murray Cumming
* Some code cleanup.
  (Murray Cumming)

1.25.3 (unstable):

* Make menu item accelerators work again.
  (Murray Cumming)
* Field Definition: Move Default formatting into a separate window.
  (Murray Cumming)
* Find (broken after the port to GAction):
  - Really stop when cancelling after none found.
  -  Show only the found records.
  - Update the menu item state.
  (Murray Cumming)
* Adjust dialog widget spacing to be more GNOME HIG-compliant.
  (Murray Cumming)
* Rearrange some dialogs to make them less tall, to (almost)
  fit in small screens.
  (Murray Cumming)
* Replace (deprecated) GtkTable with GtkGrid.
  (Murray Cumming)
* Replace our custom GtkNotebook with GtkStack.
  (Murray Cumming)

Build:
* Bundle .glade files, (most) icons, and example files into the Glom
  executable using GResource, instead of installing them.
  (Murray Cumming)
* Bundle the XSLT file into the libglom library instead of installing
  (Murray Cumming)
* Port from gnome-doc-utils to yelp-tool.
  (Murray Cumming)
* Fixes for clang compiler and scan-build analyzer warnings.
  (Murray Cumming)
* AppData file: Actually use translations.
  (Murray Cumming)

1.25.2 (unstable):

Build:
* Fix the build with --enable-warnings=fatal,
  by replacing all uses of GtkUIManager and GtkAction with
  GtkBuilder, GAction and GMenu.
  (Accelerators, such as Ctrl-Q are currently not working.)
  (Murray Cumming)
* Replace depreacted GtkHBox and GtkVBox with GtkBox in Glade files.
  (This can cause strange layout issues, but I think I caught them all.)
  (Murray Cumming)


1.25.1 (unstable):

* Startup: Do not crash when reporting check problems.
  (Murray Cumming) Bug #680411 (Bjørn Lie, Dominique Leuenberger)
* Initial dialog:
  * Fix crash with latest libxml.
  (Murray Cumming)
  * Fix the notebook vertical expansion with latest GTK+.
  (Murray Cumming)
* Avoid a crash at shutdown.
  (Murray Cumming)
* Add an AppData file for "GNOME Software".
  (Murray Cumming)
* Remove the recent files menu items in the File menu,
  because GtkRecentAction has been deprecated without replacement.
  (Murray Cumming)
* Avoid the glib warning about adding interfaces after class initialization.
  (And therefore require a recent glibmm.)
  (Murray Cumming)
* Fix the build and tests with python 3.
  You'll need to do something like this:
    export PYTHON=python3.3
      (do this before starting jhbuild, if you are using jhbuild).
    configure --with-boost-python=boost_python-mt-py33
      (or autogen.sh if building from git.)
    You will also need to have built pygobject with Python3 support.
  (Murray Cumming)
* Avoid deprecated Gtk::Stock* API.
  (Murray Cumming)


1.24.0 (stable):

* Document format: table node: Remove superfluous parent_table
  attribute.
* libglom: Various minor code cleanups.

1.23.4 (unstable):

* Fix the build with --enable-warnings=fatal.
  Do not use ev_view_set_loading() because it is deprecated.
* Fix the build on Ubuntu Raring.
  It puts libpython2.7 in /usr/lib/i386-linux-gnu/ .
* Reduce the libgda dependency version again.

1.23.3 (unstable):

* Added an --enable-mysql configure option.
  When enabled, this adds a PostgreSQL/MySQL choice in the UI,
  as with the existing --enable-sqlite configure option.
  The MySQL support is very experimental and unsupported.
  It might be removed later if nobody chooses to work on it.
* libglom: Added a dependency on libgda-mysql-5.0, because
  libglom always supports all backends regardless of the build
  option.
* Tests:
  - Simplify the code a litte.
  - Test the use of a relationship to get data.
  - Add a test that uses an example with text primary keys.

1.23.2 (unstable):

* Tests:
  - Use the locally-built glom.
  - Use the locally-built python module.
* Examples: Remove unused list_related_* layouts.

1.23.1 (unstable):

* Document:
  - Save static image data as a child text node, not an attribute.
  - Save image data (example data or static images) in base64 format,
    instead of the GDA format.
  (Murray Cumming)
* Export to po files:
  - Also export static text items, and print layouts.
  - Avoid duplicates.
    (Murray Cumming)
* Examples: Add a static image item to the Project Manager example.
  This is just so that the feature gets some testing.
  (Murray Cumming)
* Tests: Add new tests using GdkPixbufLoader to check that we can interpret
	image data as an image.
  (Murray Cumming)

1.22.1 (stable):

* Self hosting:
  - Do not allow ident authorization.
    We use trust instead when not sharing.
  - Only allow attempts from localhost when not shared.
  (Murray Cumming)
* Film Manager example: Correct the Contacts reports.
  (Murray Cumming)

Build:
* Add the --enable-ui-tests configure option.
  This lets package builders (debian and Ubuntu, for instance)
  run make check as a sanity check.
* Windows build: Fix some typos.
  (Murray Cumming) Bug #674009 (alien)
* OpenBSD: std:cerr needs <iostream>.
  (Antoine Jacoutot) Bug #673914

1.22.0 (stable):

libglom:
* Field: Remove get_holder().
* ConnectionPool: create_database(): Take a progress slot.

Build:
* Windows build fixes.
  (Murray Cumming, alien)
* Fix some warnings found by scan-build.
  (Murray Cumming)

1.21.8 (unstable):

* Fix the build with the latest gtkmm, with --enable-warnings=fatal.
* Dialog_Import_CSV_Progress: Fix an important typo.
* Tests: Set LC_TIME too.
* Improve the command-line parse/print locale warnings.

1.21.7 (unstable):

* Build: Fix some warnings from clang++.
* libglom: Remove some deprecated methods.
* libglom: LayoutItem_GroupBy: Add get and set methods for members.

1.21.6 (unstable):

* Make auto-increment fields work even if they are not primary keys.
  (Murray Cumming) Bug #661702
* Do not hide the database structure if the user does not have view rights,
  and prevent SQL errors in that case.
  (Murray Cumming) Bug #669299
* Allow printing of print layouts from the List view too, to avoid confusion.
  (Murray Cumming) Bug #670462 (alien)
* Print Layout: Avoid sometimes over-scaled images.
  (Murray Cumming) Bug #668901 (alien)
* Users/Groups:
  - Example files: Really load the table privileges.
  - Really prevent changing to developer mode for non-developers.
    Bug #669043 (alien)
  - Allow user and group names to have spaces and other special characters.
    Bug #669012 (alien)
  - Limit user and group name lengths because PostgreSQL seems to have an
    (undocumented) limit.
  - Warn if we cannot get the list of users. Bug #669178 (alien)
  - Add tests.
    (Murray Cumming)
* Button scripts: Check and warn about pygtk2 instead of crashing.
  (Murray Cumming) Bug #669196 (alien) and ##661766 (Andre Klapper) .
* ReportBuilder:
  - Make summary fields work again.
  - Add error checking.
  (Murray Cumming) Bug #669281 (alien)
* Database Preferences: Really store the organization name in the database.
  (Murray Cumming) Bug #668836 (alien)
* Field Formatting: Related Choices: Default to showing the primary key
  (Murray Cumming) Bug #668759#c21 (alien)
* Choices: Allow the field to be be other than the primary key and do not
  crash if it is not, or if it is hidden.
  (Murray Cumming) Bug #668759 (alien).
* Document: Avoid accumulating old nodes in the XML.
  (Murray Cumming)
* Examples: Remove empty group in the Lesson Planner example file.
  (Ben Konrath) Bug #671263
* libglom: Glom::Utils::get_find_where_clause_quick(): Handle an empty value properly.
  (Murray Cumming)
* Use Gtk::Application and Gtk::ApplicationWindow instead of Gtk::Main.
  So far this does not change anything whatosever for the user,
  though --help now doesn't list all options by default.
  (Murray Cumming)
* Windows build fixes (not complete).
  (Murray Cumming) Bug ##671120 (alien), Bug #670903 (alien)

1.21.5 (unstable):

* Depend on libgda 5.0.3 because we need the GdaNumeric corrections.
  This avoids errors when creating from examples, when using a 
  non-English locale. This fixes bug #668346 (Janne)

1.21.4 (unstable):

* libglom: Use std::vector instead of std::list, for consistency.
* Translations:
  - Allow the database title to be translated.
  - Default to en rather than en_US for the original locale.

1.21.3 (unstable):

* libglom: TranslatableItem: Require the caller to provide the locale to 
  get_title() instead of calling the static set_current_locale() method
  (now removed). This allows Online Glom to use translations, and it is 
  generally good to avoid the static data.
  
1.21.2 (unstable):

* Field choices:
  - Allow custom (not related) choices to be translated,
  with only the original text being stored in the database.
  This only happens when the choices are restricted, at least for now.
  - Use the appropriate type of data for choices. rather than, for instance,
  forcing German users to see (and store) 1.99 EUR instead of 1,99 EUR.
* Translations:
  - Offer non-country locales, such as de, instead of only de_DE, de_AT, etc.
  - Default to the first locale in the list, instead of none.
* Added command-line utilities to help with translation via po files:
  glom_export_po, glom_import_po, glom_export_po_all.
* Build: Added several more tests, including tests of the translation system
  and of the iso-codes XML files parsing.

1.21.1 (unstable):

* Details: Foreign key ID fields: Add a New button next to 
  the existing Find button.
* Related Choices: Allow the user to specify a sort order.
* libglom:
  - Make libglom 1.22 parallel installable with glom 1.20.
  - Document: Added get_translation_available_locales().
  - Field: Remove unused get_gda_holder_string().
  - Remove unused get_sql_format() methods.
  - DbUtils:: Added get_fields_for_table(), 
    get_fields_for_table_one_field(), get_lookup_fields(), and 
    get_lookup_value()
  - LayoutGroup:
    - Add a 
    remove_field(parent_table_name, table_name, field_name) 
    method overload, deprecating the existing method overloads.
    - Deprecate the old has_field() method and do not use it.
  - Remove unused parameternamegenerator.[h|cc] source files.
* Build:
  - Avoid deprecated glibmm API
(Murray Cumming)
 
1.20.4 (stable):

* Details: Really make non-editable multiline text fields non-editable.
  (Murray Cumming)
* Edit menu: Make the Cut/Copy/Paste menus actually work.
  (David King, Murray Cumming) Bug #518315 (Göran)
* Choices: Make sure related choices are sorted (by ID).
  The sort order can be specified in Glom 1.21/22.
* libglom: Document_XML: Remove an unimplemented method.
  Bug #666744 (yselkowitz)

1.20.3 (stable):

* Details: ID Find button: Really show the quick find feature.
* List: Really store data when the primary key is not auto-incremented.
* Add the glom_test_connection command-line tool.
* Film Manager example: Use English for Day/Night choices.

1.20.2 (stable):

* Correct parsing of quotes in example data.
* ComboBoxes: Work around GtkComboBoxText bug #612396.
  This fixes the Users/Groups dialogs and the Script Library dialog.
* libglom: DbUtils::recreate_database_from_document():
  Create groups and set table privileges too.
* More tests.

1.20.1 (stable):

* Avoid some unnecessary stdout warnings.
* Tests:
  - Added several more tests and improved existing tests.
  - Added gcov/lcov to generate test code coverage reports in HTML.
    (make gcov)

* libglom:
  - LayoutGroup: Added a remove_field(parent_table_name, table_name, field_name) 
    method overload.
  - LayoutGroup: Added a has_field(parent_table_name, table_name, field_name) 
    method overload.
  - Added DbUtils::set_fake_connection().

This is the master branch. See also the glom-1-20 branch.

2011-11-21  Murray Cumming  <murrayc@murrayc.com>

	libglom: Added DbUtils::set_fake_connection().

	* glom/libglom/db_utils.[h|cc]: Added DbUtils::set_fake_connection()
  because ConnectionPool is not public API.
	* tests/test_fake_connection.cc: Use this function instead of using 
	ConnectionPool's API.
1.20.0 (stable):

Major changes since 1.18:

* Simplified main window.
* Glom can now store and display PDFs:
  http://www.murrayc.com/blog/permalink/2011/07/14/glom-storing-pdfs/
  It can store any file format, though it can only display images and PDFs.
* Print Layout: Major overhaul with improved UI and new functionality.
* Related Records: Allow the developer to specify how many rows to show.
* Choice drop-downs can show more than 2 fields.
* Choice drop-down fields are aligned.
* Choice drop-downs can show related fields:
  http://www.murrayc.com/blog/permalink/2010/10/07/glom-choice-drop-downs-can-show-related-fields
* List columns have sensible widths.
	
Changes since 1.19.19:
* Details view:
  - Default to left-alignment for numeric fields,
  but default to right-alignment in the list view and in related 
  records lists.
  - Move the checkbutton titles to the left.
  - Make the Calendar portal work again. Bug #663310
* List view: Stop unnecessary saving of column widths.
* List view and Related Records: Disable buttons when appropriate.
  Bug #663812 (André Klapper)
* libglom: Added ConnectionPool::set_fake_connection().
* Escape database connection details properly.
* Correctly escape and quote options when spawning tar or postgres.
* Build: Use the new Gnome::Gda::Numeric API.

1.19.19 (unstable):

* Use correct escapign of SQL identifiers in the custom SQL queries 
  that change database structure or GROUPS and USERS.
  However, this will fail with quote characters due to libgda bug #663608
* Tests: Test some changes of database structure.
* Require the latest libgdamm.
  (Murray Cumming)

1.19.18 (unstable):

* tests: Add a test of backup and restore.
  (Murray Cumming)
* Require libgda 5.0.2 to fix these Glom bugs:
  - Can't see images.
    Bug #662925
  - Data doesn't display when a field is renamed to string with a hyphen.
    Bug #661655 (Ben Konrath)
  - SQL Errors when a relationship name has capital letters.
    Bug #661073
  (Murray Cumming)
* Improvements to the (not compiled by default) SQLite code.

1.19.17 (unstable):

* Make connections to central PostgreSQL servers work again.
* Details:
  - In developer mode, draw some lines, as in glom 1.18.
  - Notebook: Avoid truncating related records buttons,
    working around GtkFrame bug #662915 .
* Do not blank the data when showing the field definitions dialog.
* Fix some warnings about invalid field types with choices.
* Improvements to creation of temporary files, such as reports.
* Handle gdouble results from python functions.
* libglom:
  - Utils::sqlbuilder_get_full_query(): Improve the result.
  - Added Utils::build_sql_update_with_where_clause().
* User guide: Update the screenshots.
* tests:
  - Add Glom::Priv test, to check parsting of PostgreSQL privileges tables.
  - Add test of writing and then reading-back image data.

1.19.16 (unstable):

* Main window: Use a smaller default size.
  (Murray Cumming)
* Replace progress dialogs with a GtkInfoBar.
  (David King, Murray Cumming)
* Remove use of GtkHandleBox. Tool Palettes cannot now be 
  separated from the window.
  (Murray Cumming)
* Build: Fix the build with the latest unstable glibmm and gtkmm.
  (Murray Cumming)
* Tests:
  - Test with sqlite too.
  - Added some SQL injection tests.
  (Murray Cumming)

1.19.15 (unstable):

* Do no try to pygobject_init() the incompatible 2 version instead of 3.0.
* Self-hosting: Attempt to avoid failed shutdowns.
* Tests: More SQL injection testing.

1.19.14 (unstable):

* Details: Avoid an outdent after group titles,
  working around GtkFrame bug #644199.
* List View: Correct the default column widths.
* Command line: Correct some exit results.
* Add try/catch around all uses of std::locale(""),
  though this should probably just fail early in main().
  Bug #619445
* libglom:
  - Correct the pkg-config file.
  - Move ReportBuilder to libglom, adding a libxstl dependency.
* Tests:
  - Self Hosting: Test more expected table structure and data.
  - Add a simple SQL injection test.
  - Test report building and contents.
  - Test general XML validity of XSLT files.
* Examples:
  - Remove all column_width attributes now that the defaults are good.
  - Film Manager example: Change default table to Scenes.

1.19.13 (unstable):

* Developer:
  - Deleting tables: Remove the auto-increment's next values too.
	Bug #661653
* Details:
  - Related Records: Allow min and max rows counts instead of just a rows count.
* List: Actually show custom choices, instead of crashing.
	Bug #661764 (André Klapper)
* Print Layouts:
  - Handle related records.
  - Improve pagination.
  - Use full page width when creating standard layouts.
* About dialog: Show the version number.
* Examples: Avoid use of pygtk, which causes a crash.
  Bug #661766 (André Klapper)
* libglom: Make LayoutItem_Group::get_title_or_name() useful for portals too.
  (Murray Cumming)
* Build:
  - Avoid some deprecated GTK+ (in 3.3) and gtkmm API.
  - Improve some translatable strings, using ustring::compose().
    (Murray Cumming)
  - Some OpenBSD fixes.
    (Jasper Lievisse Adriaanse). 
  
1.19.12 (unstable):

* Added the glom_create_from_example command-line utility.
  This has no UI dependencies and might be useful when using Online Glom.
* Details:
  - Print: Use a standard print layout instead of HTML.
  - ID choosing dialog: Work around a crash in GTK+.
    Bug #660347
  - Related Records: Fix bug with a blank row when there is only one row.
  - Related Records: Do not try to navigate to an empty record.
* Find:
  - Get criteria even when a field is on the layout twice.
  - Do not show data in related records.
* Developer mode: 
  - Fields: Adapt choices fields when changing field names.
    Bug #661075
  - Simplify the default layout structure for details.
  - Details: Do not enable drag-and-drop by default.
  - Field Formatting window: Make it slightly less tall.
    See https://bugs.launchpad.net/ubuntu/+source/glom/+bug/863016
  - Layout window: Correct the vertical order of Add buttons.
* Print Layout:
  - Allow multiple pages.
  - Add experimental Create Standard feature.
  - Add an Align menu.
  - Show contents of System Preferences in Fields.
* Document:
  - Avoid writing some unnecessary XML nodes.
  - Use CSS3 formatting for colors, via Gdk::RGBA.
  (Murray Cumming)
* Build: Remove glibc-specific function call.
	(Jasper Lievisse Adriaanse) Bug #660496
* libglom:
  - LayoutItem_Portal: Added get_suitable_table_to_view_details().
  - Added layout_field_should_have_navigation().
  (Murray Cumming)

1.19.11 (unstable):

* Details:
  - Avoid an empty layout when changing to developer mode.
  (Requires libgdamm 4.99.4)
  - Images: Avoid a warning when choosing.
* Print Layout:
  - Use the correct numeric formatting.
  - Use foreground colors from the text/field formatting.
  - Related Records: Do not show editing formatting options.
  - Layout: Fix alignment/expansion of the line options.
* Remove the Add Related Table feature.
  It is useful, but it requires explanation and is probably confusing to new users.
	Of course you can still add tables and then a relationship to them manually.
  (Murray Cumming)
	
1.19.10 (unstable):

* Print Layout: Major overhaul to editing UI so it should be almost useable now.
* Related Records:
  - Allow navigation through non-editable relationships.
  - Correct automatic navigation to related records.
* Details: Avoid (failed) attempts to edit when navigating to related records.
* Avoid some invalid characters in the document.
* Script Library: Prevent a crash when opening the dialog.
* Several UI fixes to correct how widgets expand and align.
* Fix a crash when dragging items in the layout (developer mode)
* Build:
  - Use pygobject-3.0 instead of pygobject-2.0.
  - Remove the optional Maemo UI.

1.19.9 (unstable):

* Details:
  - Related Records: Allow the developer to specify how many rows to show.
  - Images: Avoid some saving of temp files.

1.19.8 (unstable):

* Details: Image fields:
  - Support PDFs and similar files via the evince-view library.
    (This adds a dependency.)
  - Support other file formats, though there will be no preview image.
  - Fix some window resizing issues.

1.19.7 (unstable):

* Details: Images:
  - Fix insanely-big windows when big image files are used.
  - Context menu: Add Open, Open With, and Save.
  (Murray Cumming) Bug #630057
  - Related Records: Show enough records.
  (Murray Cumming)
  - Do not navigate past the last row.
  (Murray Cumming) Bug #526115 comment #25 (Michael Hasselmann)
* Add exampledir variable to pkg-config file.
  (Ben Konrath) Bug #654384
* Add translator comments.
	(Murray Cumming) Bug #638996 (Joe Hansen)

	
1.19.6 (unstable):

* Simplify the main window, and slightly simplify the menus.
* Find: Make this work again, and make it case-insensitive.
* ListView: Make the rows high enough.
* Fix the About box.

1.19.5 (unstable):

* Details:
  - Make the Primary Key ID values visible again.
  - Correct the sizing of the ... date button.
* Build:
  - Adapt to the latest libgda and libgdamm API.
  - Fix the build with --enable-warnings=fatal with gtkmm 3.1 and g++ 4.6.
  - Require latest libepc, to avoid use of both GTK+ 3 and GTK+ 2.
  - Use EggSpreadTableDnd, though it has crashes during layout drag-and-drop.
(Murray Cumming
  
1.19.4 (unstable):

* Calculated fields and button scripts:
  - Properly return boolean results.
  - Initialize pygobject, to fix the use of the PyRecord API.
* libglom: Added utils::build_sql_select_count_rows().
* Fix crashes when using choices with fixed lists.
* Do not crash if PyDateTime_IMPORT fails.
* Remove some unnecessary padding/borders around the main window.
* Main window: Use a custom Notebook-like widget instead of Gtk::Notebook.
* CSV Import: Fix quoted-newline detection, so we don't drop rows.
* Use the new Gtk::ComboBox CellArea API to align columns properly.
* Build:
  - Depend on libgdamm-5.0 instead of libgdamm-4.0.
  - Remove the dependency on pygda, though we now check for
    gi.repository.Gda at startup instead.
    It is provided by libgda-5.0 (currently 4.99.x).
  - Require the latest mm-common and dist the mm-common scripts.
  - Require the latest gtksourceviewmm

1.19.3 (unstable):

* Build
  - Build with the latest gtkmm, goocanvasmm, libgdamm and gtksourceviewmm.
  - Fix the tests builds with changed linker behaviour on Ubuntu Natty.
  - Allow libglom to be built without building the Glom UI code too.
* Handle changed setlocale() behaviour on Ubuntu Natty.

1.19.2 (unstable):

* CSV Import: Actually preview and import the field values.
  (Murray Cumming) Bug #625693 (maximiliano).
* List view: Make the retry option actually work afer entering invalid data.
  (Murray Cumming)
* Details view: Solve some widget layout problems, by using
  Use EggSpreadTable from libegg instead of Glom's own FlowTable widget.
* Build:
  - Remove the gconfmm dependency, because we don't use it.
    (Murray Cumming)
  - Use upstream gettext instead Glib one.
    (Javier Jardón) Bug #631367
  - (Hopefully) solve the timing problems in the import tests, which are
    now active again.
  - Call xmlCleanupParser() because libxml++ does not anywmore.
    (Murray Cumming)

1.19.1 (unstable):

* Choices: Allow multiple extra fields, and allow them to be related fields
  or even doubly-related fields.
  See http://www.murrayc.com/blog/permalink/2010/10/07/glom-choice-drop-downs-can-show-related-fields/
* Added a --stop-auto-server-shutdown command-line option for debugging.
* Build:
  - Use gtkmm-3.0 instead of gtkmm-2.4.
  - Use goocanvasmm-2.0 instead of goocanvasmm-1.0.
  - Use gtksourceviewmm-3.0 instead of gtksourceviewmm-2.0.

1.18.0: (stable):

* Builds with gtkmm-2.24 with no use of deprecated API.

1.16.2: (stable):

* CSV Import: Actually preview and import the field values.
  Bug #625693 (maximiliano).
* List view: Make the retry option actually work afer entering invalid data.
  Bug #167818
* Build: Remove the gconfmm dependency, because we don't use it.
  (Murray Cumming)

1.16.1 (stable):

* Prevent crash when all fields have been deleted from a table, also when
  then trying to reopen the file. (Murray Cumming)
* Find: prevent duplicate error dialog when no find criteria was entered.
  (Armin Burgeier)
* Build: Fix the python module's filename.
(Murray Cumming)

1.16.0 (stable):

New features in Glom 1.16, compared to Glom 1.14:

* Field Formatting: Related Choices: Add a Show All checkbox, so that
  the list of choices can be restricted according to the relationship,
  instead of just showing all values in the related table.
  This allows the Choices to be used to narrow down a choice based on a
  choice in another field.
* Developer menu: Added Export Backup and Restore Backup menu items.
  These use PostgreSQL's pg_dump and pg_restore utilities, wrapping the
  dump and .glom file up in a .tar.gz.
  As well as allowing backups of data, this should make it easier to upgrade
  the PostgreSQL version, which some distros do automatically when upgrading
  to new major versions of Glom. This is possible because pg_restore can
  work with the pg_dump output of an older PostgreSQL version.
  See also:
  http://www.glom.org/wiki/index.php?title=Pg_dump_when_upgrading_PostgreSQL
  (Murray Cumming)

Changes in 1.16.0:

Build:
- Do not use deprecated gtkmm API (requires gtkmm 2.22).
  (Murray Cumming)
- Various small improvements
  (David King)

1.15.2 (unstable):

* Field Formatting: Related Choices: Add a Show All checkbox, so that
  the list of choices can be restricted according to the relationship,
  instead of just showing all values in the related table.
  This allows the Choices to be used to narrow down a choice based on a
  choice in another field.
  (Murray Cumming) Bug #625536 (fmyhr)
* Allow unique fields with same name in multiple tables.
  (Murray Cumming) Bug #625192 (fmyhr).
* Developer menu: Added Export Backup and Restore Backup menu items.
  These use PostgreSQL's pg_dump and pg_restore utilities, wrapping the
  dump and .glom file up in a .tar.gz.
  As well as allowing backups of data, this should make it easier to upgrade
  the PostgreSQL version, which some distros do automatically when upgrading
  to new major versions of Glom. This is possible because pg_restore can
  work with the pg_dump output of an older PostgreSQL version.
  See also:
  http://www.glom.org/wiki/index.php?title=Pg_dump_when_upgrading_PostgreSQL
  (Murray Cumming)
* Build:
  - Explicitly link with libdl for Python module loading test.
  (David King)
  - Rename the library to libglom-1-16 to be parallel-installable with
  libglom-1-14.
  - Adapt to the latest libgdamm API.
  (Murray Cumming)

1.15.1 (unstable):

* Uses Gnome::Gda::SqlBuilder in most places to avoid manually building SQL
  query strings. This should be more robust and safer.
  (Murray Cumming)
* Correct the position of "Records / Found" labels.
  (Daniel Borgmann)
* Find:
  - Make Find mode a toggle and move it to the Edit menu.
  - Fix a crash when using find mode.
  (Daniel Borgmann)
* List view:
  - Don't add a new row when cancelling editing of a placeholder row.
  - Don't allow placeholder rows to be delteted.
  (Daniel Borgmann)
* Build libglom and pyglom API documentation.
  (Murray Cumming, Daniel Elstner)

1.14.5 (stable):

* Allow unique fields with same name in multiple tables.
  (Murray Cumming) Bug #625192 (fmyhr).

1.14.4 (stable):

* Developer menu: Added Export Backup and Restore Backup menu items.
  These use PostgreSQL's pg_dump and pg_restore utilities, wrapping the
  dump and .glom file up in a .tar.gz.
  As well as allowing backups of data, this should make it easier to upgrade
  the PostgreSQL version, which some distros do automatically when upgrading
  to new major versions of Glom. This is possible because pg_restore can
  work with the pg_dump output of an older PostgreSQL version.
  See also:
  http://www.glom.org/wiki/index.php?title=Pg_dump_when_upgrading_PostgreSQL
  (Murray Cumming)
* Build: Explicitly link with libdl for Python module loading test.
  (David King)

1.14.3 (stable):

* Fix position of "Records / Found" labels.
  (Daniel Borgmann)
* List: Don't allow deleting placeholder rows.
  (Daniel Borgmann)
* Build: Don't require avahi-ui.

1.14.2 (stable):

* Fix document saving (horribly broken in 1.14.1).
* Python field calculations and button scripts:
  - Test buttons now show python errors.
  - Really convert the value to the field's type.
* Fix a crash when showing choices in some situations.
* Added several "make check" tests.
  (Murray Cumming)

1.14.1 (stable):

* Python field calculation: Fix a crash when using some date types.
* Documentation:
  Build and install libglom (C++) API reference documentation (for use by applications)
  and pyglom (Python) API reference documentation (for use by Glom calculated
  fields and button scripts).
  (Murray Cumming, Daniel Elstner, David King)
* Added unit tests. (Murray Cumming)

1.14.0 (stable):

New features in Glom 1.14, compared to Glom 1.12:
* Details:
  - Align widgets in neighbouring groups, making things look generally neater.
    (and fix a bug that made the widgets far too wide.)
* Details and List:
  Allow custom formatting of static text and buttons instead of just fields.
* Field Formatting:
  - Add the option to use a different text color for negative values.
    Suggested by Mathias Hasselmann.
  - Add a horizontal alignment option, though we still right-align numbers
    by default. Bug #591125 (Patrick Chan)
  - Allow choices to be shown as radio buttons instead of a drop-down combo box.
    Requested by Frederik Vande Rieviere.
* Many small UI improvements.
* Field calculations and button scripts:
  - Fields values may now be changed like so:
    record["fieldname"] = 123
  - Simple navigation is posible via, for instance:
    ui.show_table_list("artists")
    ui.show_table_details("artists", 10)
    where 10 is the value of the primary key in the table.
  - Added ui.print_layout(), ui.print_report(report_name),
  and ui.start_new_record() methods.
  - Added a startup script feature, in Database Preferences.
* Plus several important bug fixes.

1.14.0: (stable)

* Design Mode:
  - Notebook properties: Fix crash.
  - Reports: Secondary Fields: Fix crash.
* Creating from example:
  - Really save the new filename in the recent files list.
  (Murray Cumming, Openismus)
  - Don't show error dialog when user cancels creation from an example.
  (Daniel Borgmann, Openismus)
* Opening recent files: Warn when a file doesn't exist, and forget it,
  instead of just showing a generic error dialog.
  (Murray Cumming, Openismus)
* Python scripts and field calculations: Fix a Glom 1.13 bug with use of
  date fields.
* User Interface: General cleanup. The dialogs are more compliant with the
  GNOME HIG and there are many minor ixes to the user interface.
  (Daniel Borgmann, Openismus)
* Build:
  - Fix the build with --as-needed.
  (David King, Openismus)
  - Add tests for the Glade XML files.
  (Murray Cumming, David King, Openismus)
* Windows Installer: Update for Glom 1.14
  (Armin Burgmeier)

1.13.9 (unstable):

* Field Formatting: Allow choices to be shown as radio buttons instead of a
  drop-down combo box. Requested by Frederik Vande Rieviere.
  (Murray Cumming)
* Python scripts: Added a startup script feature, in Database Preferences.
* Initial Dialog: Do not crash sometimes if cancelling the file chooser.
  (Murray Cumming) Bug #612303 (David King)
* Build:
  - Don't use deprecated gtkmm API. This requires the latest gtkmm.
  (Murray Cumming)
  - Require the correct gtkmm and libsigc++ versions.
  (David King)
* Fix the Glade file so it can be opened with the latest glade-3 (when the
  gtksourceview glade catalog is installed).
  (David King)

1.13.8 (unstable):

* Details:
  - Align widgets in neighbouring groups, making things look generally neater.
  - Do not make field widgets too wide, so this fits on a laptop screen.
  (Murray Cumming)
* Python scripts: Added ui.print_layout(), ui.print_report(report_name),
  and ui.start_new_record() methods.
  (Murray Cumming)
* Fix the build with exceptions disabled.
  (Peter Penz )

1.13.7 (unstable):

* Avoid a crash when a script navigates from a list view to another table.
  Maybe avoid similar warnings/crashes when doing normal navigation.

1.13.6 (unstable):

* Python scripts:
  - Fields value may now be changed like so:
    record["fieldname"] = 123
  - Simple navigation is posible via, for instance:
    ui.show_table_list("artists")
    ui.show_table_details("artists", 10)
    where 10 is the value of the primary key in the table.
	(Murray Cumming)
* Avoid showing %20 in the window title.
	Noticed by Daniel Borgmann.
	(Murray Cumming)

1.13.5 (unstable):

* Python functions: Fix some regressions since the switch to boost::python.
  (Murray Cumming)
* Disable broken unit tests to fix make distcheck.
  (Murray Cumming)
* libglom: Fix build issue for Maemo.
  (Peter Penz)

1.13.4 (unstable):

* Glom now depends on boost::python.
  This release is to give disto packagers a chance to cope with that.
  (Murray Cumming)
* Fix Maemo build errors
  (Peter Penz)
  (This fix is also in glom 1.2. The boost::python dependency will make
  building of 1.13/14 on Maemo almost impossible.

1.13.3 (unstable):

* Relationships Overview: Avoid a crash and a warning when closing.
  (Murray Cumming) Bug #607938 (Michael Hasselmann)
* Import: Avoid a hang, hopefully.
  (Michael Hasselmann)
* Import: Fixed out-ouf-bounds crash.
  (Michael Hasselmann)  Bug #607938 (ialx).
* New file: Allow the title to contain quotes, avoiding weird errors.
  (Murray Cumming) Bug #607957 (Michael Hasselmann)
* libglom:
  - Improved include paths used in headers.
  (Murray Cumming)
  - Avoid crashes with invalid parameter values.
  (Michael Hasselmann)
* Use Gtk::ToolPalette, requiring gtkmm 2.19.4, instead of code copied from libegg.
* Command-line arguments: Do some checks.
  (Murray Cumming)

1.13.2 (unstable):

* Details layout: Really use the new formatting options (horizontal alignment,
  foreground color and background color) for static text items and buttons.
  (Murray Cumming)

1.13.1 (unstable):

* Details and List layouts:
  Allow custom formatting of static text and buttons instead of just fields.
  (Murray Cumming)
* Field Formatting:
  - Add the option to use a different text color for negative values.
    (suggested by Mathias Hasselmann)
  - Add a horizontal alignment option, though we still right-align numbers
    by default. #591125 (Patrick Chan)
  (Murray Cumming)

1.12.5 (stable):

* List View: Don't chop off the bottom of text when using large fonts.
  (Murray Cumming) Bug #607023 (Michael Hasselmann)
* Avoid problems when entering numbers with currency suffixes when using the
  C locale.
  (Murray Cumming, Michael Hasselmann)
* Windows: Install glom_1_12.pyd instead of glom.pyd.
  (Armin Burgmeier) Bug #605593 (Karel Brucek)
* libglom: Added NumericFormat::get_default_precision().

1.12.4 (stable):

* Drag and drop layout: Fix some crashes. This feature still has some problems,
  so the layout dialog is still available.
   (Murray Cumming) Bug #599232
* Field Definitions: Show the default value entry even for date fields.
* Python calculations/scripts:
  Fix a crash when calling python functions that return dates.
  (Murray Cumming) Bug #603686. (Andrew Ruthven)
* Details layout:
  - Related records layout definition:
  When defining drop-down choices in the custom formatting, show the correct
  relationships. Noticed by Michael Hasselmann and Andrew Ruthven.
  (Murray Cumming)
  - Fix a crash when specifying a static image on the layout.
  (Murray Cumming) Bug #600954 (Michael Hasselmann).
* Saving: Always add the xmlns ID to the document, to make MIME-type detection
  easier. (Murray Cumming)
* Do not mark an empty string for translation.
  (Murray Cumming) Bug #599868 (André Klapper).
* Avoid some runtime warnings.
  (Murray Cumming)
* Examples: Film Manager: Add silly example data.
  (Murray Cumming) Bug #600859 (Michael Hasselmann)
* Windows build: Add missing libpangoft2-1.0-0.dll to the installer.
  (Armin Burgmeier) Bug #599966 (Akishi Soda, Cinna)
* Maemo build: Don't depend on libgettextpo.
  (David King)
* Developer documentation:
  Correct the DTD and add a unit test to make sure it and the
  examples are correct.
  (Michael Hasselmann, Murray Cumming)

1.12.3 (stable):

* List: Fix zero-width columns. That regression was introduced in 1.12.2.
  (Murray Cumming)
* Developer Mode: Tables, Relationships: Allow a singular title to be specified,
  though it is currently only used on Maemo.
  (Murray Cumming)
* Windows Build:
  - Builds for Windows again. (Armin Burgmeier)
* Build: Support Automake silent rules. (Daniel Elstner)
* Maemo Build:
  - Adapted for latest hildonmm API.
  - AppMenu: Add "Add" and "Add Related" buttons, instead of having +
    buttons in the window. This does not work perfectly and needs some work.
  - Make TextViews small initially.
  - Details:
    - Show the table name in the window title.
    - Use PickerButtons instead of ComboBoxes.
  - Widget spacing improvements to match the Maemo UI spec.
   (Murray Cumming)
  - Create a libosso D-Bus service and register it, so Glom can run in the
  background like a normal Maemo application.
  - Show the application and its icon in the applications menu.
  (David King)

1.12.2 (stable):

* Details: Choices: Actually show choices drop-down lists again,
  fixing a regression in Glom 1.12.
* Export, Import: Better handling of binary image data.
  (Murray Cumming)

1.12.1 (stable):

* Related Records:
  - Fix doubly-related records portals, such as a list of
  an Artist's publishers (via their albums).
  - Portals: Prevent use of inappropriate relationships.
* Maemo: More work on the port to the Maemo 5 UI, using simpel separate windows.
* Build: Fix the build with gtkmm < 2.18.
  (Murray Cumming)
* Refactored CSV imorter and added unit tests.
  (Michael Hasselmann)


1.12.0 (stable):

What's new in Glom 1.12:

* Network sharing of self-hosted databases is now off by default, and can be
  enabled by the new File/Share On Network menu item. So you will not be
  asked for an initial password when creating a new file.
  (Murray Cumming)
* Allow field table and field anmes to use uppercase characters.
* Import and Export: Corrected the .csv file format.
* Related Records: Added a None navigation option.
* Opening: When the file format is too new, actually say so.
* libglom: Make this parallel-installable.
* Bug-fixes from Glom 1.10.
* Build: Removed the Bakery and libglade dependencies.

1.11.2 (unstable):

* Fixed deprecated-disabled build with latest gtkmm.
* Client-only build fixes.
* Maemo build fixes.
  (Johannes Schmid, Murray Cumming, Openismus)
* Refactoring of .csv importing code.
  Bug #588233.
  (Michael Hasselmann)

1.11.1 (unstable):

* Really save field definition changes again.
  Ubuntu Launchpad bug
  https://bugs.launchpad.net/ubuntu/+source/glom/+bug/394507 (elmergato)
* Allow table and field names to use uppercase characters.
  (requires the latest libgda - either libgda 4.0.4 or libgda 4.1.2.)
  Bug #587051
* Do not fail too soon when self-starting a PostgreSQL instance, though the
  time to wait until PostgreSQL should be ready is still a hard-coded number.
* Export:
  - Correct the export to use the CSV specification
    https://bugs.launchpad.net/ubuntu/+source/glom/+bug/394894 elmergato)
  - Don't open the format dialog behind the FileChooser dialog.
    Ubuntu Launchpad bug
    https://bugs.launchpad.net/ubuntu/+source/glom/+bug/397409 (elmergato)
  - Offer File overwrite confirmation.
    Ubuntu Launchpad bug
    https://bugs.launchpad.net/ubuntu/+source/glom/+bug/393229 (elmergato)
  - Allow many fields to be added to the format at once.
    Ubuntu Launchpad bug
    https://bugs.launchpad.net/ubuntu/+source/glom/+bug/393231 (elmergato)
* Import:
  - Handle commas inside quotes, and escaped quotes, as per the CSV
    specification.
    https://bugs.launchpad.net/ubuntu/+source/glom/+bug/394894 (elmergato)
* Complain about unknown command-line options instead of crashing.
* Document's MIME-type registration: Us an xmlns ID.
* Related Records: Navigation option: Hide the navigation button when the new
  "None" option is used. Bug #574360
  (Murray Cumming, Openismus)
* Various corrections to the automatic use of ports when self-hosting.
  (Armin Burgmeier, Openismus)
* When the file format is too new, show an error message that actually says so.
  (Murray Cumming)
* Initial ldtp test scripts, to test the UI.
  (Armin Burgmeier, Openismus)
* libglom:
  - Add an ABI version (1.2) to the shared library and the headers location,
    so we may break ABI painlessly when we need to.
  - Remove any client-only or PostgreSQL/SQLite ifdefs, so that libglom always
    offers all functionality, to avoid the need to have multiple versions of
    libglom installed if you have multiple Glom builds installed. Only the
    no-exceptions build option remains, because they will never be on the same
    system.
  - Remove any Maemo-specific ifdefs because libglom is non-UI.
  - Fix the pkg-config .pc file.
  - Avoid calling g_thread_init() twice, fixing a crash.
  - Correct the headers' installation location.
 (David King, Openismus)
* Build:
  - Use non-recursive build and run tests during make check.
  (Daniel Elstner, Openismus)
  - Fix crashes in the client-only build.
  (Armin Burgmeier, Openismus)
  - Fix the build on Maemo 5 (Fremantle).
  (Johannes Schmid, Openismus)

1.11.0 (unstable):

* Network sharing of self-hosted databases is now off by default, and can be
  enabled by the new File/Share On Network menu item.
  (Murray Cumming)
* Performance improvement when first connecting to the database.
  (Armin Burgmeier)
* Fix crash if the "Connect to Server" dialog is cancelled and then a document
  is opened.
  (Michael Hasselmann)
* Related Records:
  - Allow navigation to be disabled.
    (Michael Hasselmann)
  - Navigation now works to alternate specified relationships.
	  (Murray Cumming) Bug #579172 (Michael Hasselmann)
* Details:
  - Image fields: Performance improvements and user feedback.
    (Armin Burgmeier)
  - Disable the Open button next to ID fields if the field is empty.
    (Murray Cumming) Bug #565023.
* Requires gtkmm 2.14 rather than gtkmm 2.10.
* Removed Bakery dependency (by including a fork of that code).
* Removed libglade dependency (using Gtk::Builder instead).
* Require a newer goocanvasmm.
* Add runtime checks for the Python module.
* libglom: Removed dependencies on UI libraries such as GTK+.
  (Murray Cumming)

1.10.1 (stable):

* Fix crash in initial dialog, experienced on some systems.
  (Armin Burgmeir) Bug #584022 (Keir Lawson)
* Self-Hosting: Allow multiple glom instances to self-host on the same PC,
  by correcting the discovery of available network ports.
  (Armin Burgmeir)
* Allow Glom to use existing database tables again (though there is still no
  UI for this).
* Restore the check for the necessary libgda provider plugin.
  (Murray Cumming)

1.10.0 (stable):

What's new in Glom 1.10:

(Not much from the point of view of users.)
* Performance improvements, avoiding excessive network queries.
* Details: Show the Open button (but not Find) for related fields that are
  primary keys, so we can navigate to that record.
* Ported to libgda-4.0 (libgdamm-4.0)
* Sqlite backend suitable for embedded use, configurable when building Glom.
* Bug-fixes from Glom 1.8.

1.9.4: (unstable):

* Disable the sqlite backend by default. It is for embedded use with limited
  functionality. (Armin Burgmeier, Murray Cumming)
* Related records: Correct the navigation to doubly related records.
  (Murray Cumming)
* Correct loading of images from examples, preventing a crash.
  (Murray Cumming)
* Windows build: Fix the build and make reports work. (Armin Burgmeier)
  (Armin Burgmeier)
* Build fixes for the client-only build.
  (Murray Cumming, Armin Burgmeier)
* Improve the installation of libglom, adding a pkg-config file and a small
  test. This is still highly unstable.
* String corrections for translators.
  (Claude Paroz, Stéphane Raimbault)

1.9.3: (unstable)

* Fix network sharing with just-created documents.
  Bug #572982.
* Sqlite backend: Fix changing newly added fields with SQLite.
  (Armin Burgmeier)
* Build: Builds again against a released libgda version (3.99.12).
  (Murray Cumming)

1.9.2: (unstable)

* Sqlite backend:
  - Added a configure option to enable/disable sqlite support.
    This is the last Glom version that will enable sqlite by default,
    because this is only intended for embedded use, with reduced functionality.
  - Fix Find mode. Bug #570401
  - Don't lose the non-NULL field constraint when changing fields.
  - Release any existing DataModels when changing the table, to avoid sqlite
    errors. Bug #572847
  - Various fixes for field changes.
  (Armin Burgmeier)
* Networked Glom: Correct use of wrong port.
  (Armin Burgmeier) Bug #572982
* Details:
  - Avoid vast extra space when using 3 or more columns.
    Bug #539369 (maximiliano)
  - Show the Open button (but not Find) for related fields that are primary
    keys, so we can navigate to that record. Bug #571975
  - Avoid showing scientific e notation for up to 15 digits, instead of 7.
   (Murray Cumming)
* Cache the user privileges for a short time, to improve performance.
  (Murray Cumming) Bug #567473
* Import: Add a .cvs filter to the file chooser dialog.
  (David King) Bug #572702
* Avoid leaking a Gtk::EventBox.
  (Armin Burgmeier)
* Build:
  - Updated for latest libgda/libgdamm API.
  - Fixed the build with --enable-client-only.
  - Fix various minor compiler warnings.
  - Updated the .glade file to glade-3 format. Bug #567470\
  - Use the postgres executable instead of the deprecated postmaster executable.
    Bug #525108
  (Murray Cumming)

1.9.1: (unstable)

* Sqlite support: Improvements, including changing of fields types, and
  adding/deleting fields.
  (We will later make this only a configure option.)
  (Armin Burgmeier)
* Use SQL parameters where possible, making code safer and fixing problems
  with image data with libgda-4.0.
  (Johannes Schmid)
* When cancelling the initial dialog, fix the strange behaviour.
  (Johannes Schmid) Bug #569721.
* Main window: Correct the order of the widgets at the bottom-right that
  show the number of found records and the total number of records.
  (Murray Cumming)
* List view, Related Records lists:
  Really show lookup values and related fields.
  This regression was introduce in Glom 1.8, now fixed.
  (Murray Cumming) Bug #569722 (Johannes Schmid)


1.9.0: (unstable)

* Ported to libgdamm-4.0 (libgda-4.0) from libgda(mm)-3.0.
  (Johannes Schmid, Armin Burgmeier, Murray Cumming)
* Initial sqlite support as an alternative to PostgreSQL, intended for
  embedded use. There are still some obvious problems with this, but we
  expect to solve them soon in the next release, when we will also make this
  only a configure option.
  (Armin Burgmeier)
* Find: Make find mode work again in the list view.
  (Murray Cumming) Bug #565579
* Cache the connection for a few seconds to avoid unnecessary reconnects,
  making things faster. (Murray Cumming)
* Fixes from recent 1.8 releases.

1.8.1:

* Related records: Show the specified fields, not all fields.
  (Murray Cumming)
* Fix the client-only build.
  (Koop Mast) Bug #557258

Glom 1.8

Major changes since 1.6:

New features:
* Import: Comma-separated data may now be imported into the
  current table, with the help of an assistant to choose the
  field mapping.
  (Armin Burgmeier)
* Drag and Drop layout: Drag the layout items from the toolbar,
  or drag items to move them around the layout.
  (This feature may still have some bugs. The old layout window
   is still the default.)
  (Johannes Schmid)
* Print Layouts: precise layout of print outs for record details.
  (This feature is not really complete yet. The old HTML output
   is still available.)
  (Murray Cumming)
* Calendar Portal: See related records via a calendar, choosing
  one field to use for the date, and other fields to show on that
  day in the calendar.
  (Murray Cumming)
* Network sharing: Open running Glom systems via the network,
  without opening the file from the file system.
  (Murray Cumming, Mathias Hasselmann)
* New clearer initial dialog.
  (Armin Burgmeier)
* Layout: You may now choose a custom font, foreground color
  and background color for fields.
  (Murray Cumming)
* List Layout: Column widths may now be specified.
  (Murray Cumming)
* An installer for MS Windows is now available.
  (Armin Burgmeier)

Build changes:
* Removed libgnome(mm) dependency.
* Removed gnome-vfs(mm) dependency, using gio(mm) instead.
* Now uses bakery-2.6 instead of bakery-2.4.
* Added dependencies on libepc and goocanvasmm.


1.7.3:

* Print Layout: Fields can now be specified for related records
  portals, and their data appears in the printout, though the
  whole Print Layout feature is still rather unfinished.
* Print Layout list: Add a default title when adding a print layout.
* Related Records layout: Fix a bug that was introduced some time
  during 1.7.x, preventing static text and images from being added.
  (Murray Cumming)
* Drag and Drop layout: Add a related records toolbar item, to add
  portals to the layout.

1.7.2:

* Drag-and-drop Layout:
  - Hide the toolbar by default, because this feature is still
  not ready. Added a menu item to show it.
  - Added tooltips to the toolbar items.
  (Johannes Schmid)
* List Layout:
  - Allow the user to specify column widths.
  - Hide the Groups Columns column for list layouts.
  (Murray Cumming)
* Print Layout: More improvements though this is still not ready.
  - Use the same EggToolPallette toolbar as the drag-and-drop layout.
  (Murray Cumming)
* Build: Fixed a const problem with gtkmm 2.12.
* Improvements for the Windows port:
  - Check that the user is not admin (like root on Linux),
    because that would be a network security risk, and postgres
    checks too.
  - Hide the console windows when starting postgres, by using
    CreateProcess() instead of Glib::spawn().
  - Deal with some IO strangeness.
  - Initialize WinSock at startup so we can find an unused port.
  - Added the installer source files to svn.
  - Initial dialog: Hide the network item, because we do not have
    Avahi on Windows.
  (Armin Burgmeier)
* Client-only (Maemo) build:
  - Fix the build.
  - Intial Dialog: Hide the Create Database tab.
  (Johannes Schmid)
* Removed translatable property from stock labels in the glade file.
  (Claude Paroz)

Changes in 1.7.1:

New features since 1.6:
* Redesigned initial dialog.
  (Armin Burgmeier)
* Advertize running Glom systems on the network via Avahi and allow
  other users to browse for them and open them. Uses libepc.
  (Murray Cumming, Mathias Hasselmann)
* New Import feature, to import comma-separated rows of data into the
  current table.
  (Armin Burgmeier)
* (Unfinished) drag-and-drop of layout items from a toolbar, and
  right-clicking to edit item details.
  For now, you will still need the layout dialog too.
  (Johannes Schmid)
* (Unfinished) exact-layout print layout feature, for instance for
  printing out invoices or for printing on pre-printed forms.
  (Murray Cumming)
* New Calendar portal, to view related records on a calendar, using
  one of the related records' fields as the date.
  (Murray Cumming)
* Custom font, foreground color and background color for fields.
  (Murray Cumming)

Other changes:
* Field Definitions: Refuse to change a field name to one that
  already exists.
  (Murray Cumming)
* Initial Windows port.
  (Armin Burgmeier)
* Some optimization for very large tables, and some memory leak fixes,
  though really fast-enough performance must wait until we port to
  libgda 4.0.
  (Murray Cumming)
* Added : at the end of labels, as per the GNOME HIG.
  (Murray Cumming)
* Remove sentences saying that names should not have spaces or
  special characters, because they can.
  Bug #528209 (Jean-François Fortin Tam)
* Hopefully allow bug-buddy and aport to work.
  (Murray Cumming)
* Reimplemented the Relationships Overview graph dialog.
  (Murray Cumming)
* Code refactoring to make it easier to add new layout items.
  (Murray Cumming, Armin Burgmeier)
* Removed libgnome dependency, by adding a hack for showing help.
  (Armin Burgmeier)
* Port to giomm instead of gnome-vfsmm (also in Bakery).
* gcc 4.3 build fixes.
  (Jeremiah Savage) Bug #529530.

Changes in 1.6:

glom 1.6 has only minor user-visible changes compared to glom 1.4:

* New relationships Overview diagram, available via the Developers menu.
  (Rasmus Toftdahl Olesen)
* Start dialog now shows recently-opened files.
  (Armin Burgmeier)
* Button scripts and calculated fields now show python errors
  and tracebacks in a dialog box.
  (Johannes Schmid)
* Ported to libgdamm 3.0.
  (Murray Cumming, Armin Burgmeier)
* Now ignores previously-set multiline text formatting
  options for non-text fields.  Bug #443360 (Harry Mills)
  (Murray Cumming)

1.6.0 (stable)

* Depend on latest libgdamm, to fix handling of dates.
* Slightly improved handling of database server errors.

1.5.3 (unstable)

* Avoid unnecessary unsaved-changes warning dialogs.
  (Murray Cumming)
* Ignore previously-set multiline text formatting
  options for non-text fields,
  Bug #443360 (Harry Mills)
  (Murray Cumming)

1.5.2 (unstable)

* Fixed some crashes during database creation.
  (partly by depending on the latest libgdamm).
  (Murray Cumming)
* Added Galician translation.
  (Ignacio Casal Quinteiro)

1.5.1 (unstable):

* Ported to libgdamm 3.0 and pygda-3.0 (from gnome-python-extras)
  Expect crashes and strange behaviour at first because might have missed something.
  But do tell us, so we can fix it.
  (Armin Burgmeier, Murray Cumming, Openismus)
* Start dialog: Show a list of recently-opened files, if any.
  (Armin Burgmeier, Openismus)
* Enable the relationships overview feature (using goocanvas).
* Button scripts and calculated fields:
  Show python errors and tracebacks in a dialog box.
  (Johannes Schmid, Openismus)
* Improved icons, in the correct sizes.
  (Andreas Nilsson)
* File format: More robust example rows format.
* Build: Removed unnecessary dependency on libgnomecanvasmm.

1.4.3:

* en_GB (British English) locale: Correct the parsing of 4-digit years in dates again.
  (This was fixed before 1.0 but broken again soon afterwards by a translator.)

1.4.2:

* Self-Hosting:
  - Add a password confirmation entry to the dialog that asks for the initial user name and password,
  and do some checking of the input.
  (Murray Cumming)
  - Make the connection work when the hostname is not resolved as 127.0.0.1, which might be a lot of people.
  (Mathias Hasselmann, Bug #420479)
  - Warn the user when the new directory would be the same as an existing one.
  (Murray Cumming, Mathias Hasselmann, Bug #420482)
  - Do not echo the new username and password to the terminal stdout for debugging.
  This was conceivably a security problem.
  (Murray Cumming)

1.4.1:

Minor build fix, needed by some compilers.

1.4.0:

What's new since Glom 1.2.0:

* Self-hosting: Databases can now be created in a local directory, without using a
  central PostgreSQL server. PostreSQL is still used to host the database on your
  local computer. You may, for instance, send an archive of this directory in an email.
  PostgreSQL is therefore now a non-optional dependency.
  In future, a client-only version of Glom might be available for embedded devices.
* Details view:
  - Related Records: Allow viewing of doubly-related records.
  - A vertical scrollbar now allows the window to be smaller when necessary
  on your screen.
* List View: Now supports static text items, static pictures, and script buttons, as
  the Details view already did.
* Field Formatting: Allow the user to remove a previously-chosen Also Show field.
  Bug #365051 from L Davison.
* Translations: Added Import and Export buttons, so you can use
  the standard .po format. (Johannes Schmid)
* Calculated Fields and Button Scripts: Now uses Python syntax highlighting, via GtkSourceView.
  (Johannes Schmid, Dodji Seketeli)
* Added Script Library to the Developer menu, for Python code that should be reused
  (via Import) in several scripts.
* Added --debug_sql commmand-line option, which prints out the generated
  SQL commands. (Johannes Schmid)
* Adapted for the latest Postgres version (and previous versions).
* Adapted for the latest Python version (and previous versions).
* Various bug-fixes, some of which are also in the Glom 1.2.x releases.

1.3.12 (unstable, but 1.4.0 will arrive soon)

* Users and Groups UI works with later versions of Postgres.
  (at least 8.2, and maybe >= 8.0 had this problem)
* Disabled experimental Avahi support because it was unstable
  and not yet doing anything useful.
  (Murray Cumming)

1.3.11 (unstable, but 1.4.0 will arrive soon)

* Self-Hosting: Fix a bug (in our hack) that prevented this from working on Ubuntu Feisty.
  (Murray Cumming)
* Details view: Remove the unwanted shadow/frame that was introduced when we added the
  vertical scrollbar.
  (Armin Burgmeier, bug 414260)
* List view: Allow script buttons to actually respond to clicks.
  (Armin Burgmeier, bug 359284)

1.3.10 (unstable)

* Connection: Try the additional 5434 network port used by Postgres 8.2
  on (current) versions of Ubuntu Feisty.
  See Ubuntu bug https://launchpad.net/bugs/86582
* Added code (currently disabled) to show a Relationships Overview diagram,
  using goocanvas. (Rasmus Toftdahl Olesen)

1.3.9 (unstable)

* At startup, double-check that PostgreSQL is really installed,
  and quit if it is not installed, or cannot be installed.
  The source code contains example code for Ubuntu to allow the
  user to install PostgreSQL at this time, though I would prefer
  that the user did not need to do a two-stage install,
  because self-hosting with PostgreSQL is not an optional feature.
  (That would be something for a cut-down client for embedded devices.)
  (Murray Cumming)

1.3.8 (unstable)

* Self-hosting:
  - Change the name of the sub-folder used to store self-hosted database data.
  - Discover an available network port number, instead of hard-coding the port number.
  - Experimental use of avahi: The self-hosting postgres instance is advertised via avahi,
    but you can't do anything useful with it.
* Details view: Add a vertical scrollbar, so that the window's minimum height is never too big
  for average screens.

1.3.7 (unstable):

* Build fixes for Python 2.5 and 64-bit systems, hopefully.

1.3.6 (unstable):

* Self-hosting: Now works in non-English locales.
  Bug #395511 from Aurelien.
* Field Formatting: Choices: Allow the user to remove a previously-chosen Also Show field.
  Bug #365051 from L Davison.
* List Layout: Allow fixed text, fixed images, and buttons on list rows.
* Require libgda 1.2.4, to avoid crashes with unusual characters in database and table names.

1.3.5 (unstable):

* Self-hosting of databases is now possible:
  - When you create a new database (from scratch, or by opening an example template),
  you will be asked whether you want to create it locally or on an external database server.
  If you create it locally then the database data will be contained in a local directory,
  and a separate postgres process will be started to host it.
  - When you open an existing .glom file, if it was created as self-hosting, then the data
  will be found and hosted automatically.
  - This is experimental, so please do report bugs. If you start from the terminal then you
  should see interesting debug output.
* Added help documentation for the connection error dialogs, with a link to the web page
  about setting up PostgreSQL.

1.3.4 (unstable):

* Related Records: Fix SQL error when sorting doubly-related records.

1.3.3 (unstable):

* Related Records: Allow viewing of records from doubly-related records.

1.3.2 (unstable):

* Developer menu: Add a Script Library.
  This allows you to add Python modules that can be imported by your buttons scripts
  or field calculations.
* Avoid relatively rare SQL errors about ambiguous fields and non-existant fields.
* Start dialog: Attempt to avoid strange line endings.
  Bug #369602 from Javier F. Serrador.
* Build:Partial Cygwin build fix.

1.3.1 (unstable):

* Translations: Add Import and Export buttons, so you can use
  the standard .po format. (Johannes Schmid)
* Connections: Don't bother trying alternative network ports
  after one port was successful. Bug #368787 from Craig Keogh.
* Find: Prevent SQL Errors when using capital letters in table and field names.
  Bug #375605 from William Manley.
* Button scripts and calculated fields: Code now uses Python syntax-highlighting
  colors, using GtkSourceView. (Johannes Schmid, Dodji Seketeli, Murray Cumming)
* Document:
  - Store scripts and other multi-line text in XML text nodes, instead
  of attributes, to be more compatible with other (non-libxml) XML parsers,
  such as Python's minidom.
  - Store the document format version in the document, warn when saving in
  a new format, and fail to load when the format version is too new.
* Added --debug-sql commmand-line option, which prints out the generated
  SQL commands. (Johannes Schmid, Murray Cumming)


1.2.0:

New features in Glom 1.2:

* Really remember the last-viewed record on the details view when navigating
  between tables.
* List view: Remember column widths when you resize them manually.
  Bug #358089 from Peter Williams.
* Related records:
  - When clicking the open button, show a warning dialog when the related
  record indicates a non-existant doubly-related record, making navigation
  impossible.
  - Allow navigation to doubly-related records (such as products from
  invoice lines on an invoice record), even when only the ID key is shown.
* Help buttons now work, though more help text is needed.
  (Johannes Schmid and Don Scorgie)

* Developer mode:
  - Added Add Related Table item to the Tables menu. This is a time-saving
    feature to quickly create a related table and a relationship to it,
    and is a first step to implementing further refactoring functionality.
    Bug #355975.
  - Field definitions: Warn about null values and non-unique values
    when setting a primary key.
  - Related records: Allow the developer to specify to what table the user
    will be taken, or use the automatic choice.
  - List views and related records portals:
    - Allow image fields in the lists.
    - When no fields are specified, show a hint about editing the layout.
    Bug #354073 from Peter Williams.
  - Python API (Calculated fields and button scripts):
    Added record.connection and record.table_name attributes, so you can
    go wild with SQL with the whole pygda API, if you must.
    The connection is even open already, you lucky people.
    See http://www.glom.org/wiki/index.php?title=Calculated_Fields_API#Using_the_full_pygda_API
    (Murray Cumming)
  - Button scripts: Update the view after the script has run, in case it
    changed any data.
  - Field Formatting: You can now specify a number of text lines to show for
    multi-line text. Bug #355907 from Peter Williams.
  - Layout editor dialogs: Added explanatory tooltips to the Add buttons.
  - Field calculation editor: Prevent translators from translating the
    fragment of python code.

Changes since 1.1.7:

* List view: Can now show image fields.
* Design: Fields: When marking a field as the primary key, avoid crashes
  and warn about null values and non-unique values in the field.

1.1.7:

* Button scripts: After the script has run, check that the current record
  still exists, and act appropriately.
* Related records portal: Correct the loading of the specific navigation
  details from the document, so it is not lost.
* Field editing: Fix modality problem with the field details window that
  stopped it from being used.
* Register Glom as capable of handling its own MIME type. (Denis Leroy)
* Make the Help system work, though some more text is still needed.
  Bug #349357
  (Johannes Schmid, Don Scorgie)

1.1.6:

* Really remember the last-viewed record on the details view when navigating
  between tables.
* Python API (Calculated fields and button scripts):
  Added record.connection and record.table_name attributes, so you can
  go wild with SQL with the whole pygda API, if you must.
  The connection is even open already, you lucky people.
  See http://www.glom.org/wiki/index.php?title=Calculated_Fields_API#Using_the_full_pygda_API
  (Murray Cumming)
* Build fix. (Daniel Holbach)

1.1.5:

* List view: When remembering column widths, allow the columns to be
  resized smaller again. Bug #358089 from Peter Williams.
* Related Records:
  - Avoid a SQL error when showing a doubly-related field without showing
  the key field that is used in the relationship.
  - Allow the developer to specify to what table the user will be taken
  when clicking on the row button, or just use the automatic choice.
* Button scripts: Update the view after the script has run, in case it
  changed any data.

1.1.4:

* List view: Remember column widths when you resize them manually.
  Bug #358089 from Peter Williams.
* Find: Fix crash when searching on more than one field (an AND).
* Fixed some memory management problems.
  (Murray Cumming)

1.1.3:

* Added Add Related Table item to the Tables menu. This is a time-saving
  feature to quickly create a related table and a relationship to it,
  and is a first step to implementing further refactoring functionality.
  Bug #355975.
* Creating from examples: Correct a problem that could lead to Glom not
  using all the rows of example data.

1.1.2:

* Related records:
  - When clicking the open button, show a warning dialog when the related
  record indicates a non-existant doubly-related record, making navigation
  impossible.
  - Allow navigation to doubly-related records (such as products from
  invoice lines on an invoice record), even when only the ID key is shown.

1.1.1:

* Field Formatting: You can now specify a number of text lines to show for
  multi-line text.
  Bug #355907 from Peter Williams.
* Layout editor dialogs: Added explanatory tooltips to the Add buttons.
* List views and related records portals:
  When no fields are specified, show a hint about editing the layout.
  Bug #354073 from Peter Williams.
* Avoid changing example files when using them to create new files.
* Field calculation editor: Prevent translators from translating the
  fragment of python code.

1.0.5:

* Connection dialog: Use mnemonics for accessibility navigation.
  Bug #349357 from Ryan Paul.
* Details view: Date fields: Really save the new value when selecting dates from
  the calendar. Bug #349359. (Johannes Schmid).
* Design Tables: Allow table names to contain special characters such as -.
  (You will need a newer libgda to allow database names to contain these characters too.)
* Loading from examples: Handle quoted commas in the example data and reject badly
  formatted example data.
* Build:
  - Added disable-update-mime-database configure option is apparently helpful
  for distro packagers. Bug #351989. (Fryderyk Dziarmagowski)
  - Fixed warnings with gcc 4. Bug #344815. (Elijah Newren)
* Avoid some crashes when dealing with unusual situations. (Murray Cumming)
* Examples: New examples added:
  - Music Collection
  - Film Production Manager
  - Project Manager
* Documentation: Added section about calculated fields. (Murray Cumming)
* Translations:
  - New Norwegian bokmål translation (Kjartan Maraas)
  - New Hungarian translation (Gabor Kelemen)
  - Updated Vietnamese translation (Clytie Siddall)

1.0.4:

* Related Records: When clicking the details buttons, just show the details, instead
  of flicking between details, list, and then details. That was annoying.
* List View:
  - When clicking Add, put the cursor in the appropriate column.
* Check for uniqueness before setting a value for a unique or primary-key field in the
  database.
* Calculations:
  - Allow the calculations to detect empty non-text fields, via the None object.
  - Recalculate calculations when a relationship's from key is changed, if that
  relationship is used in the calculation.
* In the Edit Tables dialog and Field Defintions dialog, do not double-click to open/edit,
  because this leads to awkwardsness/surprise because single click edits the cells too.
* Layout: Slight performance and positioning improvements.
  (Murray Cumming)
* Some more Windows/Cygwin build fixes. (Yselkowitz)
* Slightly (very slightly) more tango-like application icon. (Murray Cumming)

1.0.3:

* Fields: Prevent crash when adding field in non-English locale.
* Find:
  - Fix the [Find] button next to ID fields. It was wrongly saying that there
  were no results.
  - Really offer a second find when no results are found.
  - Show the busy cursor while finding.
* Layout: Really save changes of related records portal layouts and of custom
  field formatting.
* Some Windows/Cygwin build fixes.

1.0.2:

* Added a "..." (better suggestions welcome) next to date fields, to
  show a calendar dialog. New features like this should not be in the stable
  series, but this could help to solve a strange locale bug that someone is
  experiencing.

1.0.1:

* Correct failure while creating an example for the first time.
  (though it worked when you tried again.)
* Updated translations:
  - Finnish (Ilkka Tuohela)
  - Vietnamese (Clytie Siddall)
  - Spanish (Francisco Javier F. Serrador)

1.0:

* List view: You can now click on the column headings to sort by a field.
* The busy cursor is shown during most communication or disk activity.
* Reports: The table title is now optional.

0.9.92

* Database Preferences: Added Organisation Logo field.
* Details layouts and report:
  * Added Image layout part, for arbitrary images on the layout.
* Reports:
  * Added Header and Footer parts.
  * Show images.
  * Tell the user that the report will be opened in the browser, in case the
    browser is not at the front.

0.9.91

* Creating databases: Make sure that the user is in the developer group, even if he has never
  opened an example, allowing him to change his own database.
* Date fields:
 - Show and parse 4 digits for the year, even if the locale (stftime) stupidly thinks otherwise,
   though this need attention from translators in affected locales. Fixed for en_GB (Britain).
   Was not a problem for en_US or de_DE.
* Details layouts:
 - Fields with choices are no longer insensitive when read-only, so you can now,
   for instance, select and copy text out of them, or see what is in their menus.

0.9.9:

* Details layouts:
  - Added a Notebook layout part, with tabs, so the details can show more information,
    such as several related layouts portals.
  - Stop pictures and calculated values from existing records appearing on new empty records.
* View Layouts and Reports:
  - Allow doubly-related fields. For instance, Actor::Agent::name on the Details of a
    a Character record.
  - Add a Text layout part, for arbitrary text on the Details view, or reports.
* Reports:
  - Allow top-level fields in reports, for non-grouped-by reports.
  - Allow use of Group By parts without specified group-by fields, so they
    can be (mis)used just to specify a sort field for non-grouped-by records.
  - Allow Group By parts to be sorted by multiple fields, and allow the sort
    order (ascending or descending) to be specified.
  - Added Vertical Group report part, for packing more information into a row.
  - Allow adding of fields as siblings while selecting the field, instead of
    requiring the user to select the parent group.
  - Allow custom formatting of fields.
  - Allow a border width to be specified for the records table cells.
  - Added a horizontal line below group-by titles.

0.9.8:

* Lookups: Fix intermittent problem that caused looked-up values to
  not be stored in the database.
* Related Records: Correctly reload portal layouts that use related
  (from the related table) fields, rather than just fields in the related table.
* Performance: Avoid querying for some unnecessary fields on Details view.

0.9.7:

* When creating from a read-only example, really do not mark the saved file
  as not an example, and save the new database name, so you can open it
  again from the saved file.
* Prevent duplicate table, field, relationship, and report names,
  to prevent crashes.
* Field Definition:
  - Default Value tab renamed to Value.
  - Default Values and lookups are now grouped as
    User Entry and are mutually exclusive with Calculation.
  - When changing a calculation, all values will be recalculated,
    with a warning and the chance to cancel.
  - Fix crash when changing field type to number, when not all
    existing values are valid numbers.
  - Fix crashes when converting from text to boolean.
  - Fix crashes when converting from boolean to number.
  - Preserve information when converting from anything to boolean.
* Details and List Views: Do not allow editing of calculated fields.
* Details View: Use the correct formatting for second columns in combo boxes for
  related choices.
* List View: Do not add a record when clicking on the Edit button on the last row
  - just go to the Details view.
* List layout: Warn that image fields are not supported on the
  list view yet.
* Date and Time Parsing improvements.
* New Translations:
  - Finnish (Ilkka Tuohela)
* Updated Translations:
  - Catalan (Josep Puigdemont)
  - Vietnamese (Clytie Siddall)

0.9.6:

* New built-in System Properties relationship:
  allows you to show fields from the system properties, such as
  the organisation's name and address, on a layout or report.
* The Field Layout Properties dialog (right-click on a field in
  developer mode to see the menu) now allows you to choose a custom title
  for the field for this instance, in case the regular field title is not
  appropriate. This is often the case for related fields.
* Save Field Layout Properties when the dialog closes. (Fixes a regression)
* Find:
  - Fix oddness in Details view when finding. (Fixes a regression)
  - Start Find mode on the current View, instead of always going to the Details view.
  - Find works again when you start on the Details view. (Fixes a regression)
  - Do a Find All if the find is not successful, if the user doesn't want to try again.
* Avoid python warnings when adding new records.
* Stop images from disappearing when refreshing layouts.

0.9.5:

* Details Layout:
  - Add Button layout item, to run arbitrary Python code, with access to
    the record data.
  - Fix bugs that caused the layout changes to be forgotten (regressions).
* Opening Examples:
  Do not open the Save As dialog box in the examples directory.
  Also see the latest Bakery (2.3.17) for fixes to prevent Save As in read-only paths.
* Build: Install the logo, for use by the Applications menu.

0.9.4:

* Relationships: Really save new relationships. (Fixes a regression.)
* Prevent crash when doing a lookup from a field of a different type, or via
  a relationship whose key fields are of different types.
* Prevent crashes when deleting field or relationships that are used on a layout.

0.9.3:

* Prevent crashes when using Table or Field names with uppercase characters.
* Translation:
  Added Translations menu item to Developer menu. Use this to specify
  translated table titles, field titles, layout part titles, report titles,
  etc, to be used when your Glom system is used in that locale.
* Prevent underscores from being interpreted as navigation markup in table
  and report titles.
* Performance improvements.
* The .desktop file can now be translated.
* New Translations:
  - Vietnamese (Clytie Siddall)
* Updated Translations:
  - Canadian English (Adam Weinberger)
  - Spanish (Francisco Javier F. Serrador)

0.9.2:

* Examples:
  - When you open an example you must now always save an editable copy,
  and a new database will always be created on the server.
  - Examples contain example data to fill the new database.
  - Added File / Save As Example feature in developer mode.
* New files: Create the glom system tables, to avoid the error message.
* Find:
  Quick Find: Type criteria in this entry to search all text fields.
  Found Set: The number of found records and number of total records are now
  shown at the bottom right of the window, along with a Find All button.
* Added File / Export feature, for exporting comma-separated data.
* Image fields: Choosing clear from the context menu now really clears
  the field in the database.
* Updated Translations:
  - Canadian English (Adam Weinberger)
  - Spanish (Francisco Javier F. Serrador)

0.9.1:

* List view: Show new records that were added in Details view.
  (Bug found by Daniel Holbach and Greg Breland.)
* List and Details views: Do not crash when entering ;, ', or " characters.
  (Bug #323266 from Nicolas Chevreux.)
* Dialog text grammar changes. (Bug #300139 from Adam Weinberger).
* New Translations:
  - Nepali (Pawan Chitrakar)
* Updated Translations:
  - Canadian English (Adam Weinberger)
  - Catalan (Josep Puigdemont)
  - Czech (Miloslav Trmac)
  - German (Hendrik Brandt)
  - Spanish (Francisco Javier F. Serrador)

0.9.0:

* Remembers last-viewed record and layout: If you view a record, then go
  to another table, then come back, the same record will be shown, on the
  same layout.
* Table title is now big and bold.
* Details view:
  -  ID fields that identify a unique related record (e.g. a Company ID on
  a contacts record) now have a Find button, so you can search for the
  related record, to get the ID.
  - When deleting a record, you will be asked for confirmation, as the
  list view already does. And when deleting the only record, the record
  will be blanked instead of still showing the dead record.
* Find:
  - Really searches for substrings.
  - Warns if no criteria was entered.
  - Warns if no records were found.
* Updated translations:
  - Canadian English (Adam Weinberger)
  - Spanish (Francisco Javier F. Serrador)
  - Czech (Miloslav Trmac)
  - German (Hendrik Brandt)

0.8.37:

* List view (and related records lists)
  - Instead of double-clicking to open record details, you can now click
  on the small Open button on each row.
* Details view:
  - ID fields that identify a unique related record (e.g. a Company ID on
  a contacts record) now have an Open button, so you can go quickly to
  the related record.

0.8.36:


* Layout design:
  - Don't forget related fields when reopening the layout dialog.
  - Change related field names on layouts when renaming fields.
  - Change relationship names on layouts when renaming relationships.
  - Field selection dialog: Now sorted alphabetically.
* Relationships:
  - Relationships may now optionally not allow editing of
  related fields.
  - Allow more than one relationship to the same table.

0.8.35:

* Tables: New tables have a description and a comments field as
  well as the primary key.
* Details:
  - Related fields, with automatic related-record creation:
  Really write the new value into the related record, instead of
  just creating the related record.
  - The default layout is now more useful.
  - Field titles are now visible again when there is only one
  item in a multi-column group.
* Relationships: Create a suitable title when adding a
  relationship name.

0.8.34:

* Prevented crash at startup. (Daniel Holbach)
* Added Image field type. (Murray Cumming)

0.8.33:

* Details layout: Group names can be changed again.
* Editing tables list:
  - System tables are no longer shown.
  - Prevent crash when deleting the currently-shown table.
* Editing relationships: System tables are no longer shown.


0.8.32:

* Dates: Allow parsing of, for instance, 11/5/1973 instead of
  just 11/05/1973.
* Tables:
  - Prevent crash when removing a table.
  - Update the Tables menu when adding tables.
* Accept a filename on the command line.
* Examples:
  - Add Save As button to the warning about read-only
  examples.

0.8.31:

* Initial Dialog: Added Open Examples button. The examples
  are now installed.
* Build fix when using warnings as errors.

0.8.30:

* Field Formatting: Choices from related tables: This was
  broken in 0.8.29.
* Updated screenshots.

0.8.29:

* Field Definitions: Added default formatting, so you don't
  have to specify the same formatting repeatedly.
* Make the .glom document more compact.

0.8.28:

* File/Print works for List view, printing a list of records
  in the found set.
* Reports:
  - The Summary part is now implemented, allowing totals,
  averages, and counts.
  - Group By parts may now show extra "secondary"
  fields, in addition to the field by which the records are
  grouped.
* Translations updated:
  - Spanish (Francisco Javier F. Serrador)
  - Czech (Miloslav Trmac)
  - Canadian English (Adam Weinberger)
  - British English (Gareth Owen)

0.8.27:

* Simpler Tables menu replaces the Navigation/Tables
  dialog window.
* Added simple reports functionality, via the Reports
  menu.

0.8.26:

* For new databases, really allow the developer to create
  and edit records. This has probably been broken since
  the user administration was added.
* Added Developer/Database Preferences menu item, where
  you can enter global values for the system name,
  organisation details, and specify next values for
  auto-incremented fields.
* Show the system name at the top of the window.
* Find mode: Works again.
* Hide scrollbars when they are not needed.

0.8.25:

* Details: Use a bigger widget (TextView) with scrollbars
  for multiline text fields.
* Details and List: Right-align numbers.
* Calculated fields: Do the calculations in the correct
  order of their dependencies.

0.8.24:

* Remove debug code that hardcoded one file path,
  so you can open any file.

0.8.23:

* Details and List:
  - Allow a drop-down list of choices for a field.
    Either a custom list, such as Mr, Ms, Mrs, Miss,
    or a list of related records, such as a list of
    product codes. This is demonstrated in the
    example, in the Invoices table.
- Details layout: Fields are now editable by default.
* Fixed various leaks and crashes, improved
  performance, and simplified the code some more.

0.8.22:

* Field Definitions:
  - Do not save empty default values as "NULL" or 0.
  - Prevent crash when opening Field details a second
    time.
  - Allow saving when the default value changes.
  - Calculated fields:
    - Simplified python API.
    - Aggregate calculations (sum, count, max, min)
      on related records.
    - Calculated fields may use the results of
      other calculated fields.
    - Do not lose digits after decimal points.
    (Demonstrated in the Invoice table in the example.)
* List:
  - Really do lookups and recalculations when
  adding new records.
* Details:
  - Related records: Only show related records, not
    all records.
* g++ 3.4 build fixes.
* Translations:
  - Updated Spanish (Francisco Javier Fernandez)


0.8.21:

* Calculated Fields: Your python function can now use
  the record's other field values. This requires
  the python libgda bindings in gnome-python-extras 2.11.
* List: Do lookups, and refresh related fields, when
  adding new records, not only when changing existing
  records.
* Details and Lists Layout: Field formatting is now in a
  separate dialog window.
* Boring Internals:
  - The List view's TreeModel now gets the data from the
  database dynamically on-demand, though it probably
  needs some more work to do that as efficiently as
  possible.
  - Now depends on pygtk and gnome-python-extras/libgda.
* Translations:
  Updated: Candadian English (Adam Weinberger),
  German (Hendrik Brandt), Czech (Miloslav Trmac)

0.8.20:

* Fix the boost::python build problem.
* Added highly experimental File/Print menu item. It
  does stuff in the Details view. It should open some
  HTML in your browser. glom installs an XSLT file
  used to create the HTML, so feel free to improve it.
* Translations: Added Kinyarwanda translation. (Steve Murphy)

0.8.19:

* List and Details: When defining the layout, developers
  can specify numeric formatting, such as decimal places,
  and currency symbols.
* Details: Related Records now use all available layout
  width, instead of having a fixed width.
  (Murray Cumming)
* Translations:
  - Pango markup and spaces not marked for translation.
    (Christian Rose)
  - Added Swedish (Christian Rose).
  - Updated Albanian (Laurent Dhima),
    Canadian English (Adam Weinberger),
    Czech (Miloslav Trmac),

0.8.18:

* The binary will be installed, fixing the problem in
  0.8.17. Sorry.

0.8.17:

* User/Groups Administration:
  Choosing the Developer/Users menu now allows you to
  create groups and specify view/edit/create/delete
  access rights for each table for each group.
* Developer mode: Now only possible for users who are in
  the developer group.
* Details view: You can now right-click on a field to add
  a field, group, or related records.
* Ignore pga_* tables created by pgadmin.

0.8.16:

* Relationships:
  -  Allow the developer to specify whether related records
  should be created automatically.
  - Do not clear the To Field column when the user clicks on it.
* Details/List views:
  - Automatic creation of related records:
  When you enter a value in a related field, when their is
  not yet a key value to identify the related record, a
  record can be create automatically, and the key value
  will be filled in for you.
  - Developers may set fields on the layout as non-editable.


0.8.15:

* Related Fields:
  Details and List views can now show fields from related records.
  Just choose the relationship when you choose the field on
  the layout. This even works in Related Records portals.
* Non-editable fields:
  When choosing a field for a layout, you can specify whether
  editing of the field should be allowed.
* Dialogs are more HIG-compliant, using secondary text.
* Now requires gtkmm 2.6 instead of 2.4.

0.8.14:

* Details View: Adding records works even when a field appears
  more than once in the layout.
* List View: Deleting records works again.

0.8.13:

* Details:
  - Related Records now work, including automatic addition of new
    related records.
  - In developer mode, you can right-click on fields to choose a
    different field.
  - In developer mode, you can right-click on related records to
    choose a different relationship and choose the fields to show.
  - Groups may now contain the same field more than once.
* Details and List: Automatically-generated primary keys do not
  need to be displayed.
* List: Avoid GTK+ warning when clicking on empty space in the
  TreeView.
* Example:
  - Make some fields lookup their data from relationships:
    Invoice Lines gets product information from the products table,
    and Invoices looksup the customer name from the contacts table.
  - Warn if people recreate a database on the server from a
    read-only example file, because they will probably want to
    change things.

0.8.12:

* Postgres connection:
  - Really use the template1 database when creating new databases.
  - Slightly better error handling.
* Obscure internals:
  - Use a custom GdaValue-based treemodel for the List view,
    allowing us to get data on-demand in future.

0.8.11:

* Postgres connection:
  - Connect to the template1 database when creating new databases,
    because recent (?) versions of postgres require this.
  - Don't ignore the host name.
  - Added postgres_setup.txt and a non-libgda test to help
    investigate connection problems.
  - Share connections more, without re-connecting, to increase speed.
* List Layout:
  - Fix bug that prevented data entry of fields that have
    human-readable titles.
* Layout Design:
  - Fix loss of layout groups when loading.
  - Allow adding of related records (half-finished) in the
    middle of the layout, and no longer show them automatically
    in a notebook.
    (It's really time to make this feel like glade.)
* Navigation:
  - Show table titles instead of name when in Operator mode.
* Build:
  - Distribute the intltool files.
    http://bugzilla.gnome.org/show_bug.cgi?id=162932 (Cezar)
  - #include libintl.h in more files, required on some systems.
    http://bugzilla.gnome.org/show_bug.cgi?id=162932 (Mike Castle)
  - Fix Glib::wrap() build error with gcc 3.4.3.
    http://bugzilla.gnome.org/show_bug.cgi?id=160245 (Christian Krause)

0.8.10:

* Added an example document.
* Offer to create databases on the server based on documents,
  such as examples.
* Don't display empty dates, times, and numbers as "NULL".
* Specify empty dates and times to server in SQL as "NULL", not
  as empty strings.
* Dialogs have default buttons.
* Avoided a few crashes.

0.8.9:

* Really save details of new tables in the document.
* Create the tables inside the specified database, instead of
  putting them all in the user's default postgress database.
* Enforce one database per document - ask for a new database name
  when creating a new document instead of allowing the user
  to choose an existing database.
* When there is still only one table, open it without asking the
  user to choose a table, as if it is the default table.
* Show the database title in the window title bar, instead of
  the filename.
(Murray Cumming)
* Fix an internationalization build problem. (Mike Castle)
* Added translations:
  - Gujarati (Ankit Patel)
  - Punjabi (Amanpreet Singh Alam)
  - Spanish (Francisco Javier F. Serrador)
  - Turkish (Baris Cicek)

0.8.8:

* Details Layout: Simpler, hierarchical layout. This allows
  more complex layouts, and allows fields to appear more than
  once on the same layout.
* Documentation: Added user manual, though it looks a
  bit strange in yelp at the moment.
* Relationships:
  - Avoid crash when fields of differerent types are used in
  relationships.
  - Actually delete relationships when the delete button is pressed.

0.8.7:

* Field Definition:
  - Add Boolean field type, which is displayed as a checkbox.
  - Default values can be the result of python calculations.
  - Default values are validated according to the field type.
* Pressing cancel on the initial dialog closes the application.
* Details view:
  - Corrected widget layout problems.
  - Do not lose the layout groups after a while.
  - Fix crash when changing user level, with related records.
(Murray Cumming)
* Added Albanian translation. (Laurent Dhima)

0.8.6:

* Creating new documents works again.
* Auto-save documents, when in developer mode,
  instead of asking.
* Navigation:
  - Database: Default to the linux user name.
  - Tables: Show the hidden status correctly.
* MIME type registration: Use both old and new system,
  as needed by GNOME 2.6.
* Allow a file to be specified on the command line.
* Removed useless toolbar.
  (Murray Cumming)
* Added French translation. (Christophe Merlet)

0.8.5:

* Data Details: Editing works again.
* Find mode now works, though it's simple.
* Edit buttons are now stock Open buttons.
* Renaming of tables: The new names are stored in the
  document so you can rename again, and use the renamed table.
  (Murray Cumming)

0.8.4:

* Connection dialog: The connect button is now activated when you press return in the password entry.
* Data Details: Groups of fields are now shown together in a HIG-style frame.
* Design: field, table, and layout group titles now have defaults, by replacing white space and
  capitalizing.
* Some build improvements.
  (Murray Cumming)
* Added Portugese translation (Duarte Loreto)
* Added British English translation (Gareth Owen)

0.8.3:

* Design:
  - Fields: Fix crash when opening the edit dialog.
  - Relationships: Fix editing, and actually save the relationships.
* Beginnings of user documentation.
* Updated German translation (Hendrik Brandt)

0.8.2:

* Navigation / Tables : Fixed focus bug when adding tables.
* Fields can lookup their values from a field in
  another table via a relationship.
* When a table is marked as the default then it will be
  opened automatically when the database is opened.
* Tables can now be renamed.
* List and Data views: Auto-increment fields are non-editable.
* Update the Data view when field editing has finished.
* Code cleanup: AddDel widget is now iterator-based.
(Murray Cumming)
* Czech translation. (Miloslav Trmac)
* Dutch translation. (Tino Meinen)


0.8.1:

* Details and List views: Dates, times, and numbers are now displayed
  and parsed according to the current locale.
  (Murray Cumming, Daniel Elstner)
* Removed Design Mode - Added items to the Developer menu instead.
* Details view: The entry widgets for Date, time, and number fields now
  have more suitable widths, so it looks nicer.
* User Level is now per-document (or per-instance) instead of per-application.
* The User Level is forced to Operator if the document is read-only.
* Do not show the help text because it's annoying.
  (Murray Cumming)
* Added internationalization support, with the following translations:
  Italian (Alberto Paro)
  German (Hendrik Brandt)
  Canadian English (Adam Weinberger)
  Brazilian Portugese (Gustavo Noronha Silva)
  Swedish (Christian Rose)


0.8.0:

* Now uses Postgres instead of MySQL, due to the MySQL license changes.
* Now uses libgda instead of mysqlcppapi.
* Now use libglademm to allow more improvement of the UI.
* Glom can no longer be used with database tables that it did not create.
* Now uses only a small set of simple field types.
* Added "User Level" - normal operators do not see design functionality.
  User Levels are bad, but this seems to be the only way to present the
  design functionality next to the stuff being designed.
* Allows simple layout of List and Details views. (grouping in the Details view is not yet fully implemented)
* Saves all field information in the document.
* Tables can be hidden from normal users.


0.7.0:

* Updated for latest mysqlcppapi 2 API.
* Various document-saving fixes.
  (by requiring the latest Bakery)
* Data Mode:
    Details:
      Related Records:
      - Now shows the correct related records.
      - You can now choose [Edit] to navigate to that record in the related table.
* Design Mode:
    Fields:
    - Human-readable field titles are now saved properly.
      (by requiring the latest libxml++)
    - The Field Details dialog closes when you click [Save].
